/*---------------------------------------------------------
PROGRAMA: cliente TAD ArvBin
-----------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>

#define MIN 0
#define MAX 1000

typedef int ItemArv;
#include "arvBin.h"

/* ----------------------------------------------------- 
  Função: obtem o maior valor par e o maior valor ímpar 
  armazenado na árvore
  Entrada: raiz da árvore
  Saída: maiorPar - maior valor par armazenado na árvore;
                    se não existir nenhum par, retorna com valor zero
         maiorImpar - maior valor ímpar armazenado na árvore
                    se não existir nenhum impar, retorna com valor zero
*/
void maiorParMaiorImpar( ArvBin p, ItemArv *maiorPar, ItemArv *maiorImpar ){
}

/* ----------------------------------------------------- 
  Função: verifica se a árvore binária é uma árvore binária de busca
  Entrada: raiz de árvore
  Saida: 1 se a árvore é de busca
         0 se a árvore não é de busca
*/
int ehDeBusca( ArvBin raiz ){
}


/* ----------------------------------------------------- 
  Função: espelha a árvore
  Entrada: raiz de uma subárvore
  Saída: raiz com os filhos esquerdo e direito trocados
*/
ArvBin espelha( ArvBin p ){
}

/* ----------------------------------------------------- 
  Função: troca o conteúdo dos nodos de forma que cada nodo 
          contenha o menor valor dentre os valores do nodo 
          corrente e seus filhos
  Entrada: raiz da árvore
  Saida: árvore com os valores armazenados nos nodos trocados
*/
void paiMenor( ArvBin p ){
}


/* ----------------------------------------------------- 
   Funcao: Cada nodo passa a ter um novo nodo pai     
Se o nodo contiver um valor par, ele será o filho esquerdo do seu novo pai, contendo o dobro do seu valor; se o nodo contiver um valor impar, ele será o filho direito do seu novo pai, contendo o dobro do seu valor mais 1
   Entrada: raiz de um subárvore
   Saída: nova raiz da subárvore com o dobro de nodos 
*/
ArvBin novoPai( ArvBin p ){
}

/* ======================================================*/
/* Programa Principal                                    */
/* Não deve ser alterado!!                               */
/* ======================================================*/

int main(int argc, char *argv[]){
  ArvBin arv;
  ItemArv v, maiorPar, maiorImpar;

  /* -----------------------------------------------------*/
  /* Criação de uma árvore degenerada (em forma de lista) */
  criaArv( &arv );
  printf("Insira uma sequencia de chaves. Finalize a sequencia com 0: \n");
  scanf( "%d", &v );
  while( v != 0 ){
    arv= insereArvLista( v, arv );
    scanf( "%d", &v );
  }
  printf( "Arvore Degenerada\n" );
  escreveArv( arv );
  printf( "Altura = %d\n", alturaArv( arv ));

  if( ehDeBusca( arv ))
    printf("Eh uma arvore de busca\n");
  else
    printf("Nao eh uma arvore de busca\n");
  freeArv( arv );

  /* -----------------------------------------------------*/
  /* Criação de uma árvore balanceada (inserção por nivel) */
  criaArv( &arv );
  printf("Insira uma sequencia de chaves. Finalize a sequencia com 0: \n");
  scanf( "%d", &v );
  while( v != 0 ){
    arv= insereArvNivel( v, arv );
    scanf( "%d", &v );
  }
  printf( "Arvore Balanceada\n" );
  escreveArv( arv );
  printf( "Altura = %d\n", alturaArv( arv ));

  if( ehDeBusca( arv ))
    printf("Eh uma arvore de busca\n");
  else
    printf("Nao eh uma arvore de busca\n");

  /* -----------------------------------------------------*/
  /* Obtem o maior par e maior impar */
  maiorPar= 0;
  maiorImpar= 0;
  maiorParMaiorImpar( arv, &maiorPar, &maiorImpar );
  if( maiorPar == 0 )
    printf("Nao encontrou valor par\n");
  else
    printf( "Maior par = %d\n", maiorPar );
  if( maiorImpar == 0 )
    printf("Nao encontrou valor impar\n");
  else
    printf( "Maior impar = %d\n", maiorImpar );

  /* -----------------------------------------------------*/
  /* Espelha a arvore */
  arv= espelha( arv );
  printf("Arvore espelhada\n");
  escreveArv( arv );

  /* -----------------------------------------------------*/
  /* Troca o conteudo dos nodos, colocando o menor valor na raiz */
  paiMenor( arv );
  printf("Arvore com pai menor\n");
  escreveArv( arv );

  /* -----------------------------------------------------*/
  /* Cada nodo passa a ter um novo nodo pai */
  arv= novoPai( arv );
  printf("Arvore dobrada\n");
  escreveArv( arv );

  freeArv( arv );
  return 0;
}
